Index: trunk/src/corelib/io/qfsfileengine.cpp
===================================================================
--- trunk/src/corelib/io/qfsfileengine.cpp	(revision 689)
+++ trunk/src/corelib/io/qfsfileengine.cpp	(revision 690)
@@ -912,9 +912,8 @@
   engine.
 
-  For Windows, returns the canonicalized form of the current path used
-  by the file engine for the drive specified by \a fileName.  On
-  Windows, each drive has its own current directory, so a different
-  path is returned for file names that include different drive names
-  (e.g. A: or C:).
+  For Windows and OS/2, returns the canonicalized form of the current path used
+  by the file engine for the drive specified by \a fileName.  On Windows and on
+  OS/2, each drive has its own current directory, so a different path is
+  returned for file names that include different drive names (e.g. A: or C:).
 
   \sa setCurrentPath()
Index: trunk/src/corelib/io/qfsfileengine_os2.cpp
===================================================================
--- trunk/src/corelib/io/qfsfileengine_os2.cpp	(revision 689)
+++ trunk/src/corelib/io/qfsfileengine_os2.cpp	(revision 690)
@@ -192,7 +192,4 @@
 }
 
-/*!
-    \internal
-*/
 void QFSFileEnginePrivate::nativeInitFileName()
 {
@@ -208,7 +205,4 @@
 }
 
-/*!
-    \internal
-*/
 bool QFSFileEnginePrivate::nativeOpen(QIODevice::OpenMode openMode)
 {
@@ -303,7 +297,4 @@
 }
 
-/*!
-    \internal
-*/
 bool QFSFileEnginePrivate::nativeClose()
 {
@@ -311,8 +302,4 @@
 }
 
-/*!
-    \internal
-
-*/
 bool QFSFileEnginePrivate::nativeFlush()
 {
@@ -320,7 +307,4 @@
 }
 
-/*!
-    \internal
-*/
 qint64 QFSFileEnginePrivate::nativeRead(char *data, qint64 len)
 {
@@ -384,7 +368,4 @@
 }
 
-/*!
-    \internal
-*/
 qint64 QFSFileEnginePrivate::nativeReadLine(char *data, qint64 maxlen)
 {
@@ -392,7 +373,4 @@
 }
 
-/*!
-    \internal
-*/
 qint64 QFSFileEnginePrivate::nativeWrite(const char *data, qint64 len)
 {
@@ -400,7 +378,4 @@
 }
 
-/*!
-    \internal
-*/
 qint64 QFSFileEnginePrivate::nativePos() const
 {
@@ -408,7 +383,4 @@
 }
 
-/*!
-    \internal
-*/
 bool QFSFileEnginePrivate::nativeSeek(qint64 pos)
 {
@@ -416,7 +388,4 @@
 }
 
-/*!
-    \internal
-*/
 int QFSFileEnginePrivate::nativeHandle() const
 {
@@ -424,7 +393,4 @@
 }
 
-/*!
-    \internal
-*/
 bool QFSFileEnginePrivate::nativeIsSequential() const
 {
@@ -556,14 +522,4 @@
 }
 
-/*!
-    Returns the canonicalized form of the current path used by the file
-    engine for the drive specified by \a fileName.
-
-    On OS/2, each drive has its own current directory, so a different
-    path is returned for file names that include different drive names
-    (e.g. A: or C:).
-
-    \sa setCurrentPath()
-*/
 QString QFSFileEngine::currentPath(const QString &fileName)
 {
@@ -698,7 +654,4 @@
 }
 
-/*!
-    \reimp
-*/
 QAbstractFileEngine::FileFlags QFSFileEngine::fileFlags(FileFlags type) const
 {
Index: trunk/src/corelib/io/qprocess_os2.cpp
===================================================================
--- trunk/src/corelib/io/qprocess_os2.cpp	(revision 689)
+++ trunk/src/corelib/io/qprocess_os2.cpp	(revision 690)
@@ -1742,6 +1742,4 @@
 }
 
-/*! \internal
- */
 bool QProcessPrivate::startDetached(const QString &program, const QStringList &arguments,
                                     const QString &workingDirectory, qint64 *pid)
Index: trunk/src/corelib/kernel/qcoreapplication_pm.cpp
===================================================================
--- trunk/src/corelib/kernel/qcoreapplication_pm.cpp	(revision 689)
+++ trunk/src/corelib/kernel/qcoreapplication_pm.cpp	(revision 690)
@@ -93,7 +93,6 @@
     received. Reimplement this function if you want to process window
     messages \a msg that are not processed by Qt. If you don't want
-    the event to be processed by Qt, then return true and set \a result
-    to the value that the window procedure should return. Otherwise
-    return false.
+    the event to be processed by Qt, then return true and set \a result to the
+    value that the window procedure should return. Otherwise return false.
 
     It is only directly addressed messages that are filtered. To
@@ -103,5 +102,5 @@
     QAbstractEventDispatcher::instance().
 */
-bool QCoreApplication::pmEventFilter(QMSG * /*msg*/, MRESULT * /*rc*/)
+bool QCoreApplication::pmEventFilter(QMSG * /*msg*/, MRESULT * /*result*/)
 {
     return false;
Index: trunk/src/corelib/kernel/qeventdispatcher_pm.cpp
===================================================================
--- trunk/src/corelib/kernel/qeventdispatcher_pm.cpp	(revision 689)
+++ trunk/src/corelib/kernel/qeventdispatcher_pm.cpp	(revision 690)
@@ -80,5 +80,5 @@
     processing. Its functionality is based on PM object windows. Once an
     instance of this class is created, PM window messages can be sent or posted
-    to it using send() or post() methods. Subclasses should override the
+    to it using send() or post() methods. Subclasses should implement the
     message() method to process sent or posted messages. The hwnd() method is
     used whenever a PM window handle of this object window is necessary to be
@@ -215,4 +215,12 @@
 
     \note Can be called on any thread.
+*/
+
+/*!
+    \fn QPMObjectWindow::message(ULONG msg, MPARAM mp1, MPARAM mp2)
+
+    This method is called whenever a message \a msg with parameters \a mp1 and
+    \a mp2 is received by this object window. Every subclass should implement
+    this method to do actual message processing.
 */
 
Index: trunk/src/gui/image/qpixmap_pm.cpp
===================================================================
--- trunk/src/gui/image/qpixmap_pm.cpp	(revision 689)
+++ trunk/src/gui/image/qpixmap_pm.cpp	(revision 690)
@@ -233,13 +233,13 @@
 
 /*!
-    Returns a QPixmap that is equivalent to the given \a bitmap. If \a hbmMask
-    is not NULLHANDLE, it should contain vertically adjacent AND and XOR masks
-    for the given bitmap which will be used to create a mask for the returned
-    QPixmap.
+    Returns a QPixmap that is equivalent to the bitmap given in \a hbm. If \a
+    hbmMask is not NULLHANDLE, it should contain vertically adjacent AND and XOR
+    masks for the given bitmap which will be used to create a mask for the
+    returned QPixmap.
 
     Note that this method will attempt to auto-detect the presence of the real
     alpha chennel in the high 8 bits of the 32-bit pixel value for each pixel if
-    the \a bitmap has 1 plane and the 32-bit depth. This alpha channel will be
-    used to create an alpha channel for the returned QPixmap.
+    \a hbm has 1 plane and the 32-bit depth. This alpha channel will be used to
+    create an alpha channel for the returned QPixmap.
 
     \warning This function is only available on OS/2.
@@ -350,5 +350,6 @@
 
 /*!
-    Creates a \c HPOINTER from the given QIcon. Returns the \c HPOINTER handle.
+    Creates a \c HPOINTER from the given \a icon. Returns the \c HPOINTER
+    handle.
 
     If \a isPointer is \c true, an icon size closest to the system pointer size
@@ -435,6 +436,7 @@
 
 /*!
-    Returns a QIcon that is equivalent to the given \a pointer. Optionally
-    returns pixmaps used to comprise the icon in the respective arguments.
+    Returns a QIcon that is equivalent to the pointer given in \a hpointer.
+    Optionally returns pixmaps used to comprise the icon in \a pixmap and
+    \a pixmapMini.
 
     Note that this method will attempt to auto-detect the presence of the real
Index: trunk/src/gui/kernel/qmime_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qmime_pm.cpp	(revision 689)
+++ trunk/src/gui/kernel/qmime_pm.cpp	(revision 690)
@@ -1236,5 +1236,5 @@
 /*!
     \class QPMMime
-    \brief The QMPMime class maps open-standard MIME to OS/2 PM Clipboard
+    \brief The QPMMime class maps open-standard MIME to OS/2 PM Clipboard
     formats.
     \ingroup io
@@ -1270,8 +1270,8 @@
     \endtable
 
-    Note that all "x-mime:<mime>" formats use the CFI_POINTER storage type. That
-    is, the clipboard contains a pointer to the memory block containing the MIME
-    data in the corresponding format. The first 4 bytes of this memory block
-    always contain the length of the subsequent MIME data array, in bytes.
+    Note that all "x-mime:<mime>" formats use the \c CFI_POINTER storage type.
+    That is, the clipboard contains a pointer to the memory block containing the
+    MIME data in the corresponding format. The first 4 bytes of this memory
+    block always contain the length of the subsequent MIME data array, in bytes.
 
     An example use of this class by the user application would be to map the
@@ -1321,5 +1321,5 @@
 
 /*!
-    Unregisters the MIME type identified by \a id which was previously
+    Unregisters the MIME type identified by \a mimeId which was previously
     registered with registerMimeType().
 */
@@ -1340,7 +1340,7 @@
 
 /*!
-    Allocates a block of shared memory of the given size and returns the address
-    of this block. This memory block may be then filled with data and returned
-    by convertFromMimeData() as the value of the CFI_POINTER type.
+    Allocates a block of shared memory of the given \a size and returns the
+    address of this block. This memory block may be then filled with data and
+    returned by convertFromMimeData() as the value of the \c CFI_POINTER type.
 */
 // static
@@ -1366,6 +1366,6 @@
 
 /*!
-    Frees memory allocated by allocateMemory(). Normally, not used because the
-    CFI_POINTER memory blocks are owned by the system after
+    Frees a memory block \a addr allocated by allocateMemory(). Normally, not
+    used because the \c CFI_POINTER memory blocks are owned by the system after
     convertFromMimeData() returns.
 */
@@ -1375,4 +1375,10 @@
     DosFreeMem((PVOID)addr);
 }
+
+/*!
+    \typedef QPMMime::QByteArrayList
+
+    A QList of QByteArray elemetns.
+*/
 
 /*!
@@ -1421,6 +1427,6 @@
     \fn QList<MimeCFPair> QPMMime::mimesForFormats(const QList<ULONG> &formats) const
 
-    Returns a list of mime types that will be created form the specified \a list
-    of \a formats, in order of precedence (the most suitable mime type comes
+    Returns a list of mime types that will be created form the specified list of
+    \a formats, in order of precedence (the most suitable mime type comes
     first), or an empty list if neither of the \a formats is supported by this
     converter. Note that each item in the returned list is actually a pair
@@ -1447,7 +1453,8 @@
                                            QMimeData *mimeData)
 
-    Returns a DragWorker instance suitable for converting \a mimeType to a set
-    of drag items for the Direct Manipulation (Drag And Drop) session. If this
-    converter does not support the given MIME type, this method should return 0.
+    Returns a DragWorker instance suitable for converting \a mimeType of the
+    given \a mimeData to a set of drag items for the Direct Manipulation (Drag
+    And Drop) session. If this converter does not support the given MIME type,
+    this method should return 0.
 
     See the QPMMime::DragWorker class description for more information.
@@ -1514,5 +1521,5 @@
 
     This class is a DragWorker implementation that supports standard
-    DRM_SHAREDMEM and DRM_OS2FILE and rendering mechanisms. It uses
+    \c DRM_SHAREDMEM and \c DRM_OS2FILE and rendering mechanisms. It uses
     QPMMime::DefaultDragWorker::Provider subclasses to map mime types of the
     object being dragged to rendering formats and apply preprocessing of data
@@ -1541,5 +1548,5 @@
 
     This class is a DropWorker implementation that supports standard
-    DRM_SHAREDMEM and DRM_OS2FILE and rendering mechanisms. It uses
+    \c DRM_SHAREDMEM and \c DRM_OS2FILE and rendering mechanisms. It uses
     QPMMime::DefaultDropWorker::Provider subclasses to map various rendering
     formats to particular mime types and apply postprocessing of data after
@@ -1624,6 +1631,6 @@
 
 /*!
-    Returns a string representation of the given clipboard format.
-    The string representation is obtained by querying the system atom table.
+    Returns a string representation of the given clipboard \a format. The
+    string representation is obtained by querying the system atom table.
 */
 // static
@@ -1691,9 +1698,9 @@
 
 /*!
-    Checks that the given drag \a item supports the DRM_OS2FILE rendering
+    Checks that the given drag \a item supports the \c DRM_OS2FILE rendering
     mechanism and can be rendered by a target w/o involving the source (i.e.,
-    DRM_OS2FILE is the first supported format and a valid file name with full
-    path is provided). If the function returns TRUE, \a fullName (if not NULL)
-    will be assigned the item's full source file name (composed from
+    \c DRM_OS2FILE is the first supported format and a valid file name with full
+    path is provided). If the function returns \c TRUE, \a fullName (if not
+    \c NULL) will be assigned the item's full source file name (composed from
     \c hstrContainerName and \c hstrSourceName fields).
  */
@@ -1710,5 +1717,5 @@
         // DrgVerifyNativeRMF doesn't work on my system (ECS 1.2.1 GA):
         // it always returns FALSE regardless of arguments. Use simplified
-        // hstrRMF parsing to determine whether DRM_OS2FILE is the native
+        // hstrRMF parsing to determine whether \c DRM_OS2FILE is the native
         // mechanism or not (i.e. "^\s*[\(<]\s*DRM_OS2FILE\s*,.*").
 
@@ -1770,8 +1777,9 @@
 
 /*!
-    Parses the given \a rmfs list (full rendering mechanism/format specification)
-    and builds a \a list of mechanism branches. Each mechanism branch is also a
-    list, where the first item is the mechahism name and all subsequent items are
-    formats supported by this mechanism. Returns false if fails to parse \a rmf.
+    Parses the given \a rmfs list (the full rendering mechanism/format
+    specification) and builds a \a list of mechanism branches. Each mechanism
+    branch is also a list, where the first item is the mechahism name and all
+    subsequent items are formats supported by this mechanism. Returns false if
+    fails to parse \a rmfs.
 
     \note The method clears the given \a list variable before proceeding.
Index: trunk/src/network/socket/qlocalserver_os2.cpp
===================================================================
--- trunk/src/network/socket/qlocalserver_os2.cpp	(revision 689)
+++ trunk/src/network/socket/qlocalserver_os2.cpp	(revision 690)
@@ -140,9 +140,4 @@
 }
 
-/*!
-    \internal
-
-    \sa QLocalServer::closeServer()
- */
 void QLocalServerPrivate::closeServer()
 {
@@ -161,10 +156,4 @@
 }
 
-/*!
-    \internal
-
-    We have received a notification that we can read on the listen socket.
-    Accept the new socket.
- */
 void QLocalServerPrivate::_q_onNewConnection()
 {
Index: trunk/src/network/socket/qnativesocketengine_os2.cpp
===================================================================
--- trunk/src/network/socket/qnativesocketengine_os2.cpp	(revision 689)
+++ trunk/src/network/socket/qnativesocketengine_os2.cpp	(revision 690)
@@ -121,9 +121,4 @@
 }
 
-/*! \internal
-
-    Creates and returns a new socket descriptor of type \a socketType
-    and \a socketProtocol.  Returns -1 on failure.
-*/
 bool QNativeSocketEnginePrivate::createNewSocket(QAbstractSocket::SocketType socketType,
                                          QAbstractSocket::NetworkLayerProtocol socketProtocol)